<?php
class p_minify extends cmsPlugin {
    public function __construct(){
        parent::__construct();
        $this->info['plugin']           = 'p_minify';
        $this->info['title']            = 'Минимизация js и css файлов';
        $this->info['description']      = 'Минимизация js и css файлов от SJen';
        $this->info['author']           = 'SJen';
        $this->info['version']          = '1.0';
        // Настройки по-умолчанию
         $this->config['Режим тестирования (только для админа)']     = "1";
       
       $this->events[]                 = 'PRINT_PAGE_HEAD';
    }
    public function install(){
        return parent::install();
    }
    public function upgrade(){
        return parent::upgrade();
    }
    public function execute($event, $html){
        parent::execute();
        $inUser     = cmsUser::getInstance();
        $test = $this->config['Режим тестирования (только для админа)'];
        if (($test=="1")and (!$inUser.is_admin)) {return $html;} //режим тестирования, только для админа

            if (CORE_VERSION=="1.8"){
              $js   = '';
              $css  = '';

              $matches = '';
              
              foreach($html as $key=>$value) {
                  if(mb_strstr($html[$key], '<script')) {
                      preg_match('#src="\/([^"]+)"#i',$html[$key], $matches);
                      if ($js!='') {$js.=',';}
                      $q = strpos($matches[1],'?');
                      if ($q) {$matches[1] = substr($matches[1],0,$q);}
                      $js.= $matches[1];
                      unset($html[$key]);
                  }
              }

             //CSS-файлы
              foreach($html as $key=>$value) {
                  if(mb_strstr($html[$key], '<link')) {
                      preg_match('#href="\/([^"]+)"#i',$html[$key], $matches);
                      if ($css!='') {$css.=',';}
                      $q = strpos($matches[1],'?');
                      if ($q) {$matches[1] = substr($matches[1],0,$q);}
                      $css.= $matches[1]; 
                      unset($html[$key]);
                  }
              }
              
              if ($js!='') {
                $js = 'min/f='.$js;
                $html[]='<script type="text/javascript" src="/'.$js.'"></script>';
             }
              if ($css!='') {
                $css = 'min/f='.$css;
                $html[] ='<link href="/'.$css.'" rel="stylesheet"/>';
              }
              return $html;
            }
            elseif ((CORE_VERSION=="1.9")or(CORE_VERSION=="1.9.1") ){
              $inPage = cmsPage::getInstance();
              $js   = '';
              $css  = '';

              $matches = '';
              echo '<!--';
              foreach($inPage->page_head as $key=>$value) {
                  if(mb_strstr($inPage->page_head[$key], '<script')) {
                      preg_match('#src="\/([^"]+)"#i',$inPage->page_head[$key], $matches);
                      
                      $q = strpos($matches[1],'?');
                      if ($q) {$matches[1] = substr($matches[1],0,$q);}
                      if (strpos($js,$matches[1])=== false){if ($js!='') {$js.=',';}$js.= $matches[1];}
                      unset($inPage->page_head[$key]);
                  }
              }

             //CSS-файлы
              foreach($inPage->page_head as $key=>$value) {
                  if(mb_strstr($inPage->page_head[$key], '<link')) {
                      preg_match('#href="\/([^"]+)"#i',$inPage->page_head[$key], $matches);
                      $q = strpos($matches[1],'?');
                      if ($q) {$matches[1] = substr($matches[1],0,$q);}
                      if (strpos($css,$matches[1])=== false){if ($css!='') {$css.=',';}$css.= $matches[1];}
                      unset($inPage->page_head[$key]);
                  }
              }
              echo '-->';
              if ($js!='') {
                $js = 'min/f='.$js;
                $inPage->addHeadJS($js);
             }
              if ($css!='') {
                $css = 'min/f='.$css;
                $inPage->addHeadCSS($css);
              }


              return $inPage->page_head;
            }
        return $html;
    }
    
    
}
?>